<template>
  <v-select
    v-model="selectedGuest"
    label="Контактное лицо"
    :items="guests"
    :loading="isLoading"
    hide-details
    return-object
    @update:focused="onFocus"
  >
    <template #prepend-item>
      <section class="p-3">
        <v-text-field
          :clearable="!isLoading"
          flat
          variant="solo-filled"
          prepend-inner-icon="mdi-magnify"
          placeholder="Поиск"
          type="input"
          hide-details
          density="comfortable"
          @input="onSearchInput"
          @click:clear="term = ''"
        >
          <template #append-inner>
            <v-btn
              v-tooltip:left="{ text: `Минимум символов: ${MIN_SEARCH_TERM_LENGTH}`, openOnClick: true }"
              icon="mdi-shield-alert-outline"
              variant="plain"
              size="small"
              :ripple="false"
            />
          </template>
        </v-text-field>
      </section>
    </template>

    <template #item="{ item, props: itemProps }">
      <!--Leave title empty to fix vue warnings-->
      <v-list-item
        v-bind="itemProps"
        title=""
        class="py-2"
      >
        <template #title>
          <section class="flex items-center gap-2">
            <v-icon icon="mdi-account-outline" />

            <section>
              {{ item.value.name }}
            </section>
          </section>
        </template>

        <template #subtitle>
          <section class="pt-2 ml-8">
            <span v-if="item.value.phones.at(0)">
              {{ getFormattedPhoneNumber(item.value.phones.at(0).value!) }}
            </span>

            <span v-else>
              Номер телефона не указан
            </span>
          </section>
        </template>
      </v-list-item>
    </template>

    <template #selection="{ item }">
      <section class="flex items-center gap-2">
        <v-icon icon="mdi-account-outline" />

        <section>
          {{ item.value.name }}
        </section>
      </section>
    </template>

    <template #append-item>
      <InlineLoadingIndicator
        v-if="isLoading"
        embedded
      />

      <div
        v-intersect="onFullyScrolled"
        class="h-4"
      />
    </template>

    <template #no-data>
      <EmptyState
        v-if="!isLoading && !guests.length"
        embedded
      />
    </template>
  </v-select>
</template>

<script setup lang="ts">
import { ref, watch } from 'vue';

import { HttpClient } from '@/http';
import { usePagination } from '@/composables';

import { MIN_SEARCH_TERM_LENGTH } from '@/declarations';
import { getFormattedPhoneNumber, debounce } from '@/utils';

import EmptyState from '@/components/layout/EmptyState.vue';
import InlineLoadingIndicator from '@/components/layout/InlineLoadingIndicator.vue';

const props = defineProps<{ modelValue: IGuest | null }>();
const emit = defineEmits(['update:modelValue']);

const GUESTS_LIST_SIZE = 10;

const pagination = usePagination({ size: GUESTS_LIST_SIZE });

const guests = ref<IGuest[]>([]);
const selectedGuest = ref<IGuest | null>(props.modelValue);

const term = ref('');
const isLoading = ref(false);

const onFocus = async (isFocused: boolean) => {
  if (!isFocused || isLoading.value) {
    return;
  }

  await fetchData({ reset: true });
};

const onSearchInput = debounce(500, (event: InputEvent) => {
  const target = event.target as HTMLInputElement;
  const value = target.value;

  const currentTerm = value?.trim() ?? '';

  if (currentTerm && currentTerm.length < MIN_SEARCH_TERM_LENGTH) {
    return;
  }

  term.value = currentTerm;
});

const onFullyScrolled = (isIntersecting: boolean) => {
  const isDataLoaded = (
    guests.value.length < GUESTS_LIST_SIZE
  );

  if (!isIntersecting || isDataLoaded) {
    return;
  }

  fetchData({ reset: false });
};

const fetchData = async (options: Partial<PageFetchDataOptions>) => {
  isLoading.value = true;

  if (options.reset) pagination.resetPage();
  if (!options.reset) pagination.nextPage();

  const response = await HttpClient.get<IGuest[]>('/v1/guests', {
    params: {
      limit: GUESTS_LIST_SIZE,
      offset: pagination.offset.value,
      ...(term.value && { term: term.value }),
    },
  });

  isLoading.value = false;

  if (!response.data.values) {
    return;
  }

  guests.value = options.reset
    ? response.data.values
    : [...guests.value, ...response.data.values];
};

watch(term, () => fetchData({ reset: true }));
watch(selectedGuest, value => emit('update:modelValue', value));

watch(() => props.modelValue, value => {
  selectedGuest.value = value;
});
</script>